package com.cirmuller.maidaddition.Utils.CraftingTasks;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.cirmuller.maidaddition.Utils.CraftingTasks.ItemList;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;
import javax.annotation.Nullable;
import net.minecraft.core.NonNullList;
import net.minecraft.server.level.ServerLevel;
import net.minecraft.world.item.Item;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.crafting.CraftingRecipe;
import net.minecraft.world.item.crafting.Ingredient;
import net.minecraft.world.item.crafting.RecipeType;
import net.minecraft.world.level.ItemLike;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

public class AbstractCraftingTask {
  protected Ingredient resultIngredient;
  
  protected com.cirmuller.maidaddition.Utils.CraftingTasks.AbstractCraftingTask preAbstractCraftingTask;
  
  protected CraftingCategory preCraftingCategory;
  
  protected CraftingRecipe preRecipe;
  
  protected List<CraftingRecipe> allPossibleRoutes;
  
  protected ServerLevel level;
  
  protected int count;
  
  protected static boolean initialized = false;
  
  protected static List<CraftingRecipe> recipes;
  
  protected static Logger logger = LogManager.getLogger("maidaddition");
  
  public AbstractCraftingTask(com.cirmuller.maidaddition.Utils.CraftingTasks.AbstractCraftingTask abstractCraftingTask) {
    this.resultIngredient = abstractCraftingTask.resultIngredient;
    this.preAbstractCraftingTask = abstractCraftingTask.preAbstractCraftingTask;
    this.preCraftingCategory = abstractCraftingTask.preCraftingCategory;
    this.preRecipe = abstractCraftingTask.preRecipe;
    this.level = abstractCraftingTask.level;
    this.allPossibleRoutes = abstractCraftingTask.allPossibleRoutes;
    this.count = abstractCraftingTask.count;
  }
  
  public AbstractCraftingTask(ServerLevel level, com.cirmuller.maidaddition.Utils.CraftingTasks.AbstractCraftingTask parentAbstractCraftingTask, CraftingRecipe parentCraftingRecipe, @Nullable Ingredient ingredientToCraft, @Nullable Integer count) {
    this.level = level;
    this.preAbstractCraftingTask = parentAbstractCraftingTask;
    this.preRecipe = parentCraftingRecipe;
    this.resultIngredient = ingredientToCraft;
    if (!initialized) {
      recipes = this.level.m_7465_().m_44013_(RecipeType.f_44107_);
      initialized = true;
    } 
    this.count = (count == null) ? initAndGetCount() : count.intValue();
    this.preCraftingCategory = initAndGetPreCraftingCategory();
    this.allPossibleRoutes = initAndGetAllPossibleRoutes();
  }
  
  public AbstractCraftingTask(ServerLevel level, Item item, Integer count) {
    this(level, null, null, Ingredient.m_43929_(new ItemLike[] { (ItemLike)item }, ), count);
  }
  
  private int initAndGetCount() {
    int preCountDemand = this.preAbstractCraftingTask.count;
    int preResultCountPerCrafting = this.preRecipe.m_8043_(this.level.m_9598_()).m_41613_();
    int preResumePerCrafting = getTheNumberOfIngredientResumedPerPreCrafting();
    int craftingTimes = (preCountDemand % preResultCountPerCrafting == 0) ? (preCountDemand / preResultCountPerCrafting) : (preCountDemand / preResultCountPerCrafting + 1);
    return preResumePerCrafting * craftingTimes;
  }
  
  private CraftingCategory initAndGetPreCraftingCategory() {
    if (this.preAbstractCraftingTask == null) {
      this.preCraftingCategory = CraftingCategory.RESULT;
      return CraftingCategory.RESULT;
    } 
    List<Ingredient> differentIngredient = createDifferentIngredient((List<Ingredient>)this.preRecipe.m_7527_());
    if (differentIngredient.size() == 1) {
      this.preCraftingCategory = CraftingCategory.TRANSFORM;
      boolean hasCycle = checkCycleInTransform(this);
      if (hasCycle) {
        this.preCraftingCategory = CraftingCategory.ILLEGAL;
        return CraftingCategory.ILLEGAL;
      } 
      this.preCraftingCategory = CraftingCategory.TRANSFORM;
      return CraftingCategory.TRANSFORM;
    } 
    if (differentIngredient.size() == 2) {
      if (((Ingredient)differentIngredient.get(0)).m_43908_()[0].m_41720_() instanceof net.minecraft.world.item.DyeItem || ((Ingredient)differentIngredient
        .get(1)).m_43908_()[0].m_41720_() instanceof net.minecraft.world.item.DyeItem) {
        this.preCraftingCategory = CraftingCategory.DYE;
        if (this.preAbstractCraftingTask.preCraftingCategory == CraftingCategory.DYE) {
          this.preCraftingCategory = CraftingCategory.ILLEGAL;
          return CraftingCategory.ILLEGAL;
        } 
        return CraftingCategory.DYE;
      } 
      this.preCraftingCategory = CraftingCategory.NORMAL;
      return CraftingCategory.NORMAL;
    } 
    this.preCraftingCategory = CraftingCategory.NORMAL;
    return CraftingCategory.NORMAL;
  }
  
  private boolean checkCycleInTransform(com.cirmuller.maidaddition.Utils.CraftingTasks.AbstractCraftingTask rootTask) {
    if (this.preAbstractCraftingTask == null)
      return false; 
    if (this.preCraftingCategory == CraftingCategory.TRANSFORM) {
      if (isSameIngredient(this.preAbstractCraftingTask.resultIngredient, rootTask.resultIngredient))
        return true; 
      return this.preAbstractCraftingTask.checkCycleInTransform(rootTask);
    } 
    return false;
  }
  
  public static List<Ingredient> createDifferentIngredient(List<Ingredient> ingredients) {
    List<Ingredient> result = new ArrayList<>(ingredients.size());
    for (Ingredient ingredient : ingredients) {
      boolean isContainedInResult = false;
      for (Ingredient resultIngredient : result) {
        if (isSameIngredient(resultIngredient, ingredient)) {
          isContainedInResult = true;
          break;
        } 
      } 
      if (!isContainedInResult)
        result.add(ingredient); 
    } 
    return result;
  }
  
  public List<com.cirmuller.maidaddition.Utils.CraftingTasks.AbstractCraftingTask> createAbstractCraftingTasksList(CraftingRecipe recipe) {
    List<Ingredient> differentIngredient = createDifferentIngredient((List<Ingredient>)recipe.m_7527_());
    List<com.cirmuller.maidaddition.Utils.CraftingTasks.AbstractCraftingTask> result = new ArrayList<>(differentIngredient.size());
    differentIngredient.forEach(ingredient -> result.add(new com.cirmuller.maidaddition.Utils.CraftingTasks.AbstractCraftingTask(this.level, this, recipe, ingredient, null)));
    for (com.cirmuller.maidaddition.Utils.CraftingTasks.AbstractCraftingTask task : result) {
      if (task.preCraftingCategory == CraftingCategory.ILLEGAL)
        return null; 
    } 
    return result;
  }
  
  private int getTheNumberOfIngredientResumedPerPreCrafting() {
    int result = 0;
    NonNullList nonNullList = this.preRecipe.m_7527_();
    for (Ingredient ingredient : nonNullList) {
      if (isSameIngredient(ingredient, this.resultIngredient))
        result++; 
    } 
    return result;
  }
  
  private List<CraftingRecipe> initAndGetAllPossibleRoutes() {
    List<CraftingRecipe> result = new ArrayList<>(3);
    for (CraftingRecipe recipe : recipes) {
      if (this.resultIngredient.test(recipe.m_8043_(this.level.m_9598_())))
        result.add(recipe); 
    } 
    return result;
  }
  
  public static boolean isSameIngredient(Ingredient a, Ingredient b) {
    List<Item> aItem = new ArrayList<>((a.m_43908_()).length);
    List<Item> bItem = new ArrayList<>((b.m_43908_()).length);
    Arrays.<ItemStack>stream(a.m_43908_()).toList().forEach(itemStack -> aItem.add(itemStack.m_41720_()));
    Arrays.<ItemStack>stream(b.m_43908_()).toList().forEach(itemStack -> bItem.add(itemStack.m_41720_()));
    return isEqualItemList(aItem, bItem);
  }
  
  public static boolean isEqualItemList(List<Item> a, List<Item> b) {
    for (Item item : a) {
      if (!b.contains(item))
        return false; 
    } 
    for (Item item : b) {
      if (!a.contains(item))
        return false; 
    } 
    return true;
  }
  
  public int getCount() {
    return this.count;
  }
  
  public boolean isLegalCrafting() {
    return (this.preCraftingCategory != CraftingCategory.ILLEGAL);
  }
  
  public ItemList getMaterialsList() {
    List<ItemList> allPossibleItemList = new ArrayList<>();
    for (CraftingRecipe recipe : this.allPossibleRoutes) {
      List<com.cirmuller.maidaddition.Utils.CraftingTasks.AbstractCraftingTask> tasks = createAbstractCraftingTasksList(recipe);
      if (tasks != null) {
        ItemList currentItemList = new ItemList();
        for (com.cirmuller.maidaddition.Utils.CraftingTasks.AbstractCraftingTask task : tasks)
          currentItemList.addAll((Collection)task.getMaterialsList()); 
        allPossibleItemList.add(currentItemList);
      } 
    } 
    if (allPossibleItemList.isEmpty()) {
      ItemList result = new ItemList();
      result.add(new ItemStack((ItemLike)this.resultIngredient.m_43908_()[0].m_41720_(), this.count));
      return result;
    } 
    return ItemList.getAbundantItemList(allPossibleItemList);
  }
}
